from adari_core.utils.utils import fetch_kw_or_default

def met1(hdul):
    m = [
        "DET.READ.SPEED: " + str(fetch_kw_or_default(hdul["PRIMARY"], "HIERARCH ESO DET READ SPEED", default="N/A")),
    ]
    return m

def meta(hdul):
    metadata = [
       "DET.READ.SPEED: " + str(fetch_kw_or_default(hdul["PRIMARY"], "HIERARCH ESO DET READ SPEED", default="N/A")),
       "INS.SLIT.NAME: " + str(fetch_kw_or_default(hdul["PRIMARY"], "HIERARCH ESO INS SLIT NAME", default="N/A")),
       "INS.EXP.MODE: " + str(fetch_kw_or_default(hdul["PRIMARY"], "HIERARCH ESO INS EXP MODE", default="N/A")),
    ]
    return metadata

class GiraffeSetupInfo:
    def dark(hdul):
        metadata = met1(hdul)
        return metadata

    def bias(hdul):
        metadata = met1(hdul)
        return metadata

    def detmon(hdul):
        metadata = met1(hdul)
        return metadata

    def flat(hdul):
        metadata = meta(hdul)
        return metadata

    def wavecalibration(hdul):
        metadata = meta(hdul)
        return metadata

    def response(hdul):
        metadata = meta(hdul)
        metadata = metadata + [
           "OBS.TARG.NAME: " + str(fetch_kw_or_default(hdul["PRIMARY"], "HIERARCH ESO OBS TARG NAME", default="N/A")),
        ]
        return metadata
